routes/web.php
<?php

use App\Http\Controllers\AdminController;
use App\Http\Controllers\AdminPermissionController;
use App\Http\Controllers\articlesController;
use App\Http\Controllers\AuthorAuthController;
use App\Http\Controllers\Cms\Auth\LoginController as AuthLoginController;
use App\Http\Controllers\AuthorAuthControole;
use App\Http\Controllers\authorController;
use App\Http\Controllers\categoryController;
use App\Http\Controllers\Cms\Auth\LoginController;
use App\Http\Controllers\Cms\HomeController as CmsHomeController;
use App\Http\Controllers\commentController;
use App\Http\Controllers\contactRequestController;
use App\Http\Controllers\HomeController;
use App\Http\Controllers\PermissionController;
use App\Http\Controllers\RoleController;
use App\Http\Controllers\RolePermissionController;
use App\Http\Controllers\SearchConrtoller;
use App\Http\Controllers\settingController;
use App\Http\Controllers\UserAuthController;
use App\Http\Controllers\UserController;
use App\Models\ContactRequest;
use GuzzleHttp\Middleware;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', [HomeController::class,'index'])->name('home');

Route::get('/blog/{id}',  [HomeController::class,'show'])
->name('home-article');

Route::get('/author/{id}',  [HomeController::class,'showAuthor'])
->name('home-author');
Route::get('/category/{id}',  [HomeController::class,'showCategory'])
->name('home-category');

Route::post('/blog/{id}/comment',[HomeController::class,'StorCommment'])->name('comments-user')->middleware('auth:user');

// Route::get('/employee',[SearchConrtoller::class,'index']);
Route::post('/search',[SearchConrtoller::class,'showSearch'])->name('search');

// Route::prefix('cms/admin')->name('cms.')->middleware('guest:admin')->group(function(){
//     Route::get('login',[LoginController::class,'showLoginForm'])->name('login');
//     Route::post('login',[LoginController::class,'login'])->name('login');
//     // Auth::routes();
// });



Route::prefix('cms/author')->middleware('guest:author')->group(function () {
    Route::get('login', [AuthorAuthController::class, 'showLogin'])->name('auth-author.login.view');
    Route::post('login', [AuthorAuthController::class, 'login'])->name('auth-author.login');
});



Route::prefix('user')->middleware('guest:user')->group(function () {
    Route::get('login', [UserAuthController::class, 'showLogin'])->name('auth-user.login.view');
    Route::post('login', [UserAuthController::class, 'login'])->name('auth-user.login');
});




Route::get('cms/dashboard',[CmsHomeController::class,'index'])->name('cms.dashboard')
->middleware('auth:admin,author');




Route::prefix('cms/admin')->name('admin.')->middleware('guest:admin')->group(function(){
    Route::get('login',[AuthLoginController::class,'showLoginForm'])->name('auth.login.view');
    Route::post('login',[AuthLoginController::class,'login'])->name('login');
    // Auth::routes();
});



Route::get('logout', [UserAuthController::class, 'logout'])->name('auth-user.logout')->middleware('auth:user');




Route::prefix('cms')->middleware('auth:admin,author')->group(function(){
Route::resource('admins', AdminController::class);
// Route::view('', 'cms.dashboard')->name('cms.dashboard');
Route::resource('contacts', contactRequestController::class);
Route::resource('comments', commentController::class);


Route::resource('roles', RoleController::class);
Route::resource('permissions', PermissionController::class);

Route::resource('admins.permissions', AdminPermissionController::class);
Route::resource('role.permissions', RolePermissionController::class);

Route::resource('settings', settingController::class)->only(['index','store']);
Route::resource('users', UserController::class);
Route::resource('authors', authorController::class);
Route::resource('categories', categoryController::class);
Route::resource('articles', articlesController::class);


Route::get('edit-password', [AuthorAuthController::class, 'editPassword'])->name('auth.edit-password');
Route::put('update-password', [AuthorAuthController::class, 'updatePassword'])->name('auth.update-password');

Route::get('author/logout', [AuthorAuthController::class, 'logout'])->name('auth-author.logout');
Route::get('logout', [AuthLoginController::class, 'logout'])->name('auth.logout');



});
Route::view('lsl', 'cms.search.index');


// Auth::routes();

// Route::get('/home', [App\Http\Controllers\HomeController::class, 'index'])->name('home');

app/Models/ContactRequest.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class ContactRequest extends Model
{
    use HasFactory;
    public function user(){
        return $this->belongsTo(User::class,'user_id','id');
    }

}

app/Http/Controllers/Cms/HomeController.php
<?php

namespace App\Http\Controllers\Cms;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;

class HomeController extends Controller
{
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    {
    }

    /**
     * Show the application dashboard.
     *
     * @return \Illuminate\Contracts\Support\Renderable
     */
    public function index()
    {
        return view('cms.dashboard');

    }
}

app/Http/Controllers/contactRequestController.php
<?php

namespace App\Http\Controllers;

use App\Models\ContactRequest;
use Illuminate\Http\Request;

class contactRequestController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        //
        $contacts=ContactRequest::all();
        return response()->view('cms.ContactRequest.index',['contacts'=>$contacts]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
        return response()->view('cms.ContactRequest.create');

    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
        $validator = Validator($request->all(), [
            'title' => 'required|string|min:2|max:45',

            'message' => 'required|string|min:2|max:45',
        ]);

         if (!$validator->fails()) {
            $contact = new ContactRequest();
            $contact->title = $request->get('title');

            $contact->message = $request->get('message');
            $contact->user_id=auth('web')->user()->id;
            $isSaved = $contact->save();
         return response()->json(['message' => $isSaved ? 'Contact Request created successfully' : 'Failed to create Contact Request !'], $isSaved ? 201 : 400);

        } else {
           return response()->json(['message' => $validator->getMessageBag()->first()], 422);
    }
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
        $contact=ContactRequest::FindOrFail($id);
        return response()->view('cms.ContactRequest.edit',['contact'=>$contact]);
        }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
        $validator = Validator($request->all(), [
            'title' => 'required|string|min:2|max:45',

            'message' => 'required|string|min:2|max:45',
        ]);

         if (!$validator->fails()) {
            $contact = ContactRequest::findOrFail($id);
          $contact->title = $request->get('title');

            $contact->message = $request->get('message');
            $contact->user_id=auth('web')->user()->id;
            $isSaved = $contact->save();

         return response()->json(['message' => $isSaved ? 'Contact Rerquest Updated successfully' : 'Failed to Update Contact Request!'], $isSaved ? 201 : 400);

        } else {
           return response()->json(['message' => $validator->getMessageBag()->first()], 422);
    }
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
        $IsDeleted=ContactRequest::destroy($id);
if($IsDeleted){
    // return redirect()->back();
    return response()->json(['titel'=>'Deleted','message'=>'Contact Request Deleted Successfully','icon'=>'success'],200);

}else{
    return response()->json(['titel'=>'Failed','message'=>' Deleted Contact Request Failed','icon'=>'error'],400);


}
    }
}

resources/views/cms/ContactRequest/create.blade.php
@extends('cms.parent')

@section('title','Create Contact Request')
@section('page-name','Create Contact Request')
@section('main-page','Contact Request')
@section('sub-page','Create Contact Request')

@section('styles')

<!-- Toastr -->
<link rel="stylesheet" href="{{ asset('cms/plugins/toastr/toastr.min.css') }}">


@endsection

@section('content')
    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <div class="row">
          <!-- left column -->
          <div class="col-md-12">
            <!-- general form elements -->
            <div class="card card-primary">
              <div class="card-header">
                <h3 class="card-title">Create Admin</h3>
              </div>
              <!-- /.card-header -->
              <!-- form start -->
              <form role="form" id="create_form"  >
                {{-- @csrf --}}
                <div class="card-body">

                <div class="form-grup">





                  <div class="form-group">
                    <label for="first_name">Title</label>
                    <input type="text" class="form-control" id="title" name="title" placeholder="Enter title"  >
                    {{-- minlength="3" --}}
                </div>






                  <div class="form-group">
                    <label for="first_name">Message</label>
                    <input type="text" class="form-control" id="message" name="message" placeholder="Enter message">
                  </div>


                </div>
                <!-- /.card-body -->

                <div class="card-footer">
                    <button type="button" onclick="store()" class="btn btn-primary">Save</button>
                </div>
              </form>
            </div>
            <!-- /.card -->
          </div>
          <!--/.col (left) -->
        </div>
        <!-- /.row -->
      </div><!-- /.container-fluid -->
    </section>
    <!-- /.content -->
@endsection

@section('scripts')
 <!-- bs-custom-file-input -->
<script src="{{ asset('cms/plugins/bs-custom-file-input/bs-custom-file-input.min.js') }}"></script>

<!-- Toastr -->
<script src="{{ asset('cms/plugins/toastr/toastr.min.js') }}"></script>


    <script>
        //  $('#create_form').validate();
        // $('#create_form').submit(function(e){
        //     e.preventDefault();
function store(){
    var data = new FormData(document.getElementById('create_form'));

axios.post('{{ route('contacts.store') }}',data)
.then(function (response) {
    console.log(response);
    // document.getElementById('create_form').reset();
    showToaster(response.data.message, true);
})
.catch(function (error) {
    console.log(error.response);
    showToaster(error.response.data.message, false);
});
}


        function showToaster(message, status){
            if(status){
                toastr.success(message);
            }else{
                toastr.error(message);
            }
        }
    </script>

@endsection

resources/views/cms/ContactRequest/edit.blade.php
@extends('cms.parent')

@section('title','Create Admin')
@section('page-name','Create Admin')
@section('main-page','Admins')
@section('sub-page','Create Admin')

@section('styles')

<!-- Toastr -->


@endsection

@section('content')
    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <div class="row">
          <!-- left column -->
          <div class="col-md-12">
            <!-- general form elements -->
            <div class="card card-primary">
              <div class="card-header">
                <h3 class="card-title">Edit Admin</h3>
              </div>
              <!-- /.card-header -->
              <!-- form start -->
              <form role="form" id="edit_form" action="{{ route('contacts.update' , $contact) }}" method="post" >
                @csrf
                @method('PUT')
                <div class="card-body">

                <div class="form-grup">





                  <div class="form-group">
                    <label for="first_name">Title</label>
                    <input type="text" class="form-control" id="title" value="{{ $contact->title }}" name="title" placeholder="Enter title"  required>
                    {{-- minlength="3" --}}
                </div>

                  <div class="form-group">
                    <label for="email">Message</label>
                    <input type="text" class="form-control" id="message" name="message" value="{{ $contact->message }}" placeholder="Enter Message">
                  </div>



                  </div>
                <!-- /.card-body -->

                <div class="card-footer">
                    <button type="submit" class="btn btn-primary">Save</button>
                </div>
              </form>
            </div>
            <!-- /.card -->
          </div>
          <!--/.col (left) -->
        </div>
        <!-- /.row -->
      </div><!-- /.container-fluid -->
    </section>
    <!-- /.content -->
@endsection

@section('scripts')
 <!-- bs-custom-file-input -->
<script src="{{ asset('cms/plugins/bs-custom-file-input/bs-custom-file-input.min.js') }}"></script>

<!-- Toastr -->


    <script>
        //  $('#create_form').validate();
        $('#edit_form').submit(function(e){
            e.preventDefault();

            var data = new FormData(this);

            axios.post('{{ route('contacts.update',$contact) }}',data)
            .then(function (response) {
                console.log(response);
                showToaster(response.data.message, true);
            })
            .catch(function (error) {
                console.log(error.response);
                showToaster(error.response.data.message, false);
            });
        });


    </script>

@endsection

resources/views/cms/ContactRequest/index.blade.php
@extends('cms.parent')

@section('title','Contact Request')
@section('page-name','Index ContactRequest')
@section('main-page',' ContactRequest')
@section('sub-page','Index')

@section('styles')
<link href="https://unpkg.com/tailwindcss@^2/dist/tailwind.min.css" rel="stylesheet">
@endsection

@section('content')
<section class="content">
    <div class="container-fluid">
        <!-- /.row -->
        <div class="row">
   <div class="col-12">
    <div class="card">
      <div class="card-header">
    <h3 class="card-title">Contact Request</h3>
 <div class="card-tools">
  <div class="input-group input-group-sm" style="width: 50px;">
     <input type="text" name="table_search" class="form-control float-right"
 placeholder="Search">

    <div class="input-group-append">
     <button type="submit" class="btn btn-default"><i class="fas fa-search"></i></button>
      </div>
    </div>
     </div>
     </div>
       <!-- /.card-header -->
    <div class="card-body table-responsive p-0">
        <table class="table table-hover table-bordered text-nowrap">
      <thead>
                <tr>
                  <th>#</th>
          <th>Title</th>
          <th>Meesage</th>
          <th>Created At</th>
          <th>Updated At</th>
          <th>Settings</th>
      </tr>
  </thead>
  <tbody>
    @foreach ($contacts as $contact)
    <tr>
        <td>{{ $contact->id }}</td>
        <td>{{ $contact->title}}</td>
        <td>{{ $contact->message }}</td>
        <td>{{ $contact->created_at->format('Y-m-d') }}</td>
        <td>{{ $contact->updated_at->format('Y-m-d') }}</td>
              <td>
                <div class="btn-group">  <a href="{{ route('contacts.edit',$contact->id) }}" type="button"
                    class="btn btn-info"><i class="fas fa-edit"></i></a>
                {{-- {{-- @if(Auth::user()->id != $admin->id) --}}
                {{-- <form role="form" class="destroy" method="POST" action="{{ route('contactRequest.destroy',$contact->id) }}">
                   @csrf
                    @method('DELETE')
                    <button type="submit" class="btn btn-danger"><i class="fas fa-trash"></i></button>                                             </form> --}}

                    {{-- @endif  --}}
                    <a href="#"  onclick="confirmDestroy({{ $contact->id }},this)" class="btn btn-danger"><i class="fas fa-trash"></i></a>

           </div>
       </td>
   </tr>
   @endforeach
</tbody>
</table>
</div>
<div class="card-footer clearfix">
{{-- {{ $admins->links() }} --}}
{{-- {{ $admins->render }} --}}
</div>
<!-- /.card-body -->
</div>
<!-- /.card -->
</div>
</div>
<!-- /.row -->
</div>
</section>
@endsection

@section('scripts')
<script>
    function confirmDestroy(id, td){
        console.log('City ID:'+id);

        Swal.fire({
  title: 'Are you sure?',
  text: "You won't be able to revert this!",
  icon: 'warning',
  showCancelButton: true,
  confirmButtonColor: '#3085d6',
  cancelButtonColor: '#d33',
  confirmButtonText: 'Yes, delete it!'
}).then((result) => {
  if (result.isConfirmed) {
    destroy(id, td);
  }


});
    }
function destroy(id, td){
             axios.delete('/cms/user/contacts/'+id)
            .then(function (response) {
                console.log(response.data);

                swalAlert(response.data);
                td.closest('tr').remove();
            })
            .catch(function (error) {

            console.log(error.response);

            swalAlert(error.response.data);
                // console.log(error);
            })
            .then(function () {
                // always executed
  });
}

function swalAlert(data){

            Swal.fire({
            title: data.title,
            text: data.message,
            icon:data.icon,
            timer: 2000,
            timerProgressBar: false,
                    didOpen: () => {
            Swal.showLoading()
            timerInterval = setInterval(() => {
            const content = Swal.getHtmlContainer()
            if (content) {
                const b = content.querySelector('b')
                if (b) {
                b.textContent = Swal.getTimerLeft()
                }
            }
            }, 100)
        },
        willClose: () => {
            // clearInterval(timerInterval)
        }
        }).then((result) => {
        /* Read more about handling dismissals below */
        if (result.dismiss === Swal.DismissReason.timer) {
            console.log('I was closed by the timer')
        }
        })
}

</script>
@endsection